Page MenuHomePhabricator

Getting the Android app on translatewiki
Closed, ResolvedPublic

Description

This is a tracking bug to find out what we need to do to get the Android app on translate wiki.


Version: 1.0.0 (Android)
Severity: enhancement

Details

Reference
bz31467

Event Timeline

bzimport raised the priority of this task from to High.Nov 21 2014, 11:53 PM
bzimport set Reference to bz31467.
Tfinc created this task.Oct 7 2011, 1:00 AM
brion added a comment.Oct 7 2011, 1:11 AM

The current code has ..... no localization support whatsoever. :)

Need to:

  1. pick or create a localization library & file format
  2. add stub English files
  3. start changing code to use it
  4. figure out how to get it set up on TWN

For the StatusNet Desktop client (we never did finish i18n for the mobile version) I made a stub library:

https://www.gitorious.org/statusnet-client/statusnet-client/blobs/master/StatusNet%20Desktop/Resources/model/statusnet_locale.js

using a simple XML key-value file format based on that used by native localization support that Titanium was adding. PhoneGap doesn't seem to have a built-in standard localization helper, so might be good to adapt some of that (there's some basic logic for merging fallback languages iirc).

The key-value format is pretty straightforward and should be easy to adapt to TWN. Or, if there's something TWN already understands natively we could go with that and maybe be easier. :)

Reedy added a comment.Oct 7 2011, 1:13 AM

Don't TW already support a couple of formats used in Java projects?

FreeCol is one Java project

Seems like an excellent time to help the phonegap project standardize on locale message files.

brion added a comment.Oct 7 2011, 1:17 AM

All the UI is done in HTML/JS/CSS (Phonegap), so Android or Java-specific formats don't necessarily help us...

FreeCol uses simple .properties stringlist files, which are a pretty straightforward format though so we could easily build on that, I think.

Reedy added a comment.Oct 7 2011, 1:19 AM

(In reply to comment #3)

Seems like an excellent time to help the phonegap project standardize on locale
message files.

Sounds like a nice plan to somewhat helping upstream! :)

brion added a comment.Oct 7 2011, 1:28 AM

There is a Globalization plugin (thanks IBM!) which can fetch some locale information, format numbers & dates etc -- useful!

https://github.com/phonegap/phonegap-plugins/tree/master/Android/Globalization
etc

Nothing there to help with basic strings and parameter replacement though...

I think my inclination might be to snarf the 'Message' class from MediaWiki's JavaScript code and hook it up to a backend that reads strings from .properties files (unless we find a nicer way to do it). We could repackage that as a nice platform-independent lib...

brion added a comment.Oct 7 2011, 4:35 AM

Here's a stub using MediaWiki's existing front-end localization framework. Just uses messages to do the loader dialog, but it's an example of basic param composing and using the framework. :)

Included a messages-qqq.js with descriptions too -- I'm full service!

Shouldn't be too hard to load other languages, and can consider switching the file format around to something TranslateWiki-friendly (it's just a .js stub setting a map as a variable, much like our MessagesXx.php files).

https://github.com/nitobi/Wikipedia/pull/28

john wrote:

-patch, no patch in sight.

(In reply to comment #8)

-patch, no patch in sight.

What do you mean? We've already merged in brions patch for this. Now someone just needs to tackle the rest of the strings.

Talked with Niklas during triage about what it would take to get this
app on twn with the current messages and he said the “yes but output
would be plain ugly”
https://github.com/brion/Wikipedia/commit/100720287c7ab00d8c21e3831046a0ac67254e7f#diff-5

  • Bug 32265 has been marked as a duplicate of this bug. ***

philinje wrote:

Kul says Russian is urgent as well.

brion added a comment.Nov 9 2011, 3:26 PM

So do we still need to write an input/output module for Extension:Translate? Any further process to go through with setup?

Ok stuff should be pretty ready to go -- additional things were split out to blocking bugs and have been closed out.

On TranslateWiki end remains:

  • need to set up the WikipediaMobile namespace
  • need to make sure the checkout/import/export/commit cycle works

It's now on twn, but I'm unable to export.

(In reply to comment #15)

It's now on twn, but I'm unable to export.

You mean unable to push, right?

Yes, I can export [not tested yet] and commit, but not push.

One more thing: I need a small logo to add this project into the translatewiki.net front page.

Phabricator_maintenance renamed this task from Getting the Android app on translatewiki (tracking) to Getting the Android app on translatewiki.Aug 13 2016, 9:30 PM